%  WavePath -- initialize path to include WaveLab 
%
	fprintf('Welcome to WaveLab v .701 \n')
	disp('Setting Global Variables')
%
	global WAVELABPATH
	global PATHNAMESEPARATOR
	global PREFERIMAGEGRAPHICS
	global MATLABPATHSEPARATOR
	PREFERIMAGEGRAPHICS = 1;
%
	Friend = computer;
	if strcmp(Friend,'MAC2'),
		% wigglet.stanford.edu
		WAVELABPATH = 'Matlab:MATLAB 4.2c:toolbox:WaveLab:';
		PATHNAMESEPARATOR = ':';
		MATLABPATHSEPARATOR = ';';
	elseif strcmp(Friend,'DEC_RISC')
		% tukey.stanford.edu
		WAVELABPATH = '/u0/wavelab/WaveLab/';
		PATHNAMESEPARATOR = '/'
		MATLABPATHSEPARATOR = ':';
	elseif strcmp(Friend,'SUN4');
		% sunshine.arc.nasa.gov
		WAVELABPATH = '/u1/donoho/WaveLab/';  
		PATHNAMESEPARATOR = '/';
		MATLABPATHSEPARATOR = ':';
	elseif strcmp(Friend,'SGI64');
		% sunshine.arc.nasa.gov
		WAVELABPATH = '/noted/shin/tom/Wave0701/WaveLab/';  
		PATHNAMESEPARATOR = '/';
		MATLABPATHSEPARATOR = ':';
	elseif strcmp(Friend(1:2),'PC');
		% gates@microsoft.com
		WAVELABPATH = 'c:\matlab\toolbox\wavelab\';  
		PATHNAMESEPARATOR = '\';
		MATLABPATHSEPARATOR = ';';
	else
		disp('I don*t recognize this computer; ')
		disp('Pathnames not set; solution: edit WavePath.m')
	end
%
	global MATLABVERSION
	MATLABVERSION = 4.0;
%
	if strcmp(Friend,'MAC2') | strcmp(Friend,'DEC_RISC') | ...
		strcmp(Friend,'SUN4') | strcmp(Friend(1:2),'PC') ...
	        | strcmp(Friend,'SGI64'),
		
		p = path;
		pref = [MATLABPATHSEPARATOR WAVELABPATH];
		post = PATHNAMESEPARATOR;
		p = [p pref];
		p = [p pref 'Continuous'        post];
		p = [p pref 'Datasets'			post];
		p = [p pref 'DeNoising'			post];
		p = [p pref 'Documentation'		post];
		p = [p pref 'FastAlgorithms'	post];
		p = [p pref 'Interpolating'		post];
		p = [p pref 'Meyer'				post];
		p = [p pref 'Orthogonal'		post];
		p = [p pref 'Packets'			post];
		p = [p pref 'Packets2'			post];
		p = [p pref 'Papers'			post];
		p = [p pref 'Pursuit'			post];
		p = [p pref 'Stationary'		post];
		p = [p pref 'Symmetric'			post];
		p = [p pref 'Utilities'			post];
		p = [p pref 'Wigner'			post];
		p = [p pref 'Workouts'			post];

		pref = [MATLABPATHSEPARATOR WAVELABPATH];
		pref = [pref 'Papers'			post];
		p = [p pref 'Adapt'				post];
		p = [p pref 'Asymp'				post];
		p = [p pref 'Blocky'			post];
		p = [p pref 'Ideal'				post];
		p = [p pref 'MinEntSeg'			post];
		p = [p pref 'ShortCourse'		post];
		p = [p pref 'SpinCycle'			post];
		p = [p pref 'Tour'				post];
		p = [p pref 'VillardDeLans'		post];

		pref = [MATLABPATHSEPARATOR WAVELABPATH]; 
		pref = [pref 'Workouts'			post];
		p = [p pref 'BestOrthoBasis'	post];
		p = [p pref 'MatchingPursuit'	post];
		p = [p pref 'Toons'				post];

		pref = [MATLABPATHSEPARATOR WAVELABPATH]; 
		pref = [pref 'Browsers' post];
		p = [p pref 'One-D' post];

		path(p);
		disp('Pathnames Successfully Set')
		clear p pref post
	end
%
	fprintf('global WAVELABPATH = "%s"\n',              WAVELABPATH)
	fprintf('global PATHNAMESEPARATOR = "%s"; ',  PATHNAMESEPARATOR)
	fprintf('global MATLABVERSION = %g\n',            MATLABVERSION)
	fprintf('global PREFERIMAGEGRAPHICS = %g\n',PREFERIMAGEGRAPHICS)
	fprintf('WaveLab v .701 Setup Complete\n\n')
	fprintf('Available Demos - Figures from the following papers:\n')
	fprintf('  AdaptDemo  - ``Adapting to Unknown Smoothness via Wavelet Shrinkage''''\n')
	fprintf('  AsympDemo  - ``Wavelet Shrinkage: Asymptopia?''''\n')
	fprintf('  BlockyDemo - ``Smooth Wavelet Decompositions with Blocky Coefficient Kernels''''\n')
	fprintf('  IdealDemo  - ``Ideal Spatial Adaptation via Wavelet Shrinkage''''\n')
	fprintf('  MESDemo    - ``Minimum Entropy Segmentation''''\n')
	fprintf('  SCDemo     - ``Nonlinear Wavelet Methods for Recovery of Signals, Densities\n')
	fprintf('                  and Spectra from Indirect and Noisy Data''''\n')
	fprintf('  SpinDemo   - ``Translation-Invariant De-Noising''''\n')
	fprintf('  TourDemo   - ``Wavelet Shrinkage and W.V.D. -- A Ten-Minute Tour''''\n')
	fprintf('  VdLDemo    - ``WaveLab and Reproducible Research''''\n\n')
	fprintf('Available Workouts:\n')
	fprintf('  BBWorkout  - Workouts for Best Basis\n')
	fprintf('  MPWorkout  - Workouts for Matching Pursuit\n')
	fprintf('  MultiFrac  - Workouts for Continuous Wavelet Transform\n')
	fprintf('  Toons      - The Cartoon Guide to Wavelets\n\n')
%
% the next statement leaves items in global workspace
%  but hides them from local workspace
%
	clear WAVELABPATH MATLABVERSION PATHNAMESEPARATOR
	clear Friend PREFERIMAGEGRAPHICS MATLABPATHSEPARATOR

