% In this file I make up patterns for scaling
% functions at various scales. These patterns can
% then be stored into a file for later use.
% same as detfig02.m except that I do this for
% an exponential 
% also we will normalize the patterns so that 
% the E_k term is the same as for C2 scaling function.
% e.g. we are defining our base waveform so that
% all base waveforms should give same detector performance.



  N = 2^14;

  M = 10;
  J = log2(N);
  L = J-M;
  qmf = sqrt(2)*coifwavf('coif2');
  wname = ['c2e'];
  Kvec = [6 7 8];
  gamma = 1;

  load [ttliu.matlab.wpaper]c2patp

optscale = sqrt(2);

  for k = Kvec
    phi = make2exp(makephi(qmf,k-1),optscale);
    philen = length(phi);
    [m,mi] = max(abs(phi));

    sig = zeros(N,1);
  
    span = (N/2-mi) + (1:philen);
    sig(span) = phi(:);
    [m,mi] = max(abs(sig));


    sti = fwt_ti(sig,L,qmf);

    dstat = compute_dstat(sti,gamma);
    [m,mi ] = max(dstat)

    pattern = dstat_pattern(sti,mi,gamma,0,20);
    eval(['bpattern = c2_',num2str(k),';']);
    E_k = sum(pattern(:,3).^2 .* 2.^(-gamma*pattern(:,1)))
    base_E_k = sum(bpattern(:,3).^2 .* 2.^(-gamma*bpattern(:,1)))
    scalefactor = sqrt(base_E_k/E_k);

    pattern(:,3) = scalefactor*pattern(:,3);
    eval([wname,'_',num2str(k), ' = pattern;']);
    eval([wname,'_',num2str(k),'sc = scalefactor;']);
  end
