% Make up the figure that shows the
% ratio of max E_k / min E_k as a function of gamma and for
% various values of k
% Usage: First run fig_vargam.m, then run fig_vargamplot.m
%
% uses: coifwavf, makephi, compute_dstat, FWT_TI


  N = 2^14;

  M = 10;
  J = log2(N);
  L = J-M;
  qmf = sqrt(2)*coifwavf('coif2');
  wname = ['c2'];
  Kvec = [1:8];
  gammavec = [0:.1:2];

ratios = zeros(length(gammavec),length(Kvec));
gind = 1;
for gamma = gammavec
gamma
  for kind = 1:length(Kvec)
     k = Kvec(kind);

    phi = makephi(qmf,k-1);
    philen = length(phi);
    [m,mi] = max(abs(phi));

    sig = zeros(N,1);
  
    span = (N/2-mi) + (1:philen);
    sig(span) = phi(:);
    [m,mi] = max(abs(sig));


    sti = FWT_TI(sig,L,qmf);

    dstat = 2^(k*gamma)*(compute_dstat(sti,gamma));
     

   ratios(gind,kind) = max(abs(dstat))/min(abs(dstat));
  end
  gind = gind + 1;
end

save vargam ratios Kvec gammavec
