% Script File:
%  Core Program called by run_detsim3.m
% uses: track_ridges2,match_pat







	 [hits,kmax,no1,no2] = track_ridges2(stat,scalerange,detwidth,cthresh,absiprod_on,gamma);
	 nhits = hits;
	 nkmax = kmax;


	   numhits(trial,2*(detind-1)+toff) = length(hits);
           numsearch(trial,2*(detind-1)+toff) = no1;
           numsearch2(trial,2*(detind-1)+toff) = no2;




	   for numtest = testsuite1

        	dmat = zeros(nummatch,2);

		if(numtest == 1) 
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%brute force match over scales and delays
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		for mind = 1:nummatch
 	          mscale = matchscales(mind);
		  eval(['pattern = pat',num2str(mscale),';']);
  		  iprod = match_pat(stat,pattern,gamma,...
        	             delays,mode);
                  if absiprod_on
	             iprod = abs(iprod);
	          end
                  [dmat(mind,1),mi] = max(iprod);
		   dmat(mind,2) = delays(mi);
		 end



		elseif(numtest == 2) 
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%peak tracking with hits
                % at each matching scale m , we only
                % compute inner product for those peaks
		% which have peak scale of m+1
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		 for mind = 1:nummatch
 	          mscale = matchscales(mind);
		  usehits = find(kmax-1 == mscale);
                  if ~isempty(usehits)
      		   eval(['pattern = pat',num2str(mscale),';']);

	           %note: thisnref is the peak location of the scaling
		   % the nref (peak location of the scaling function used to
                   % make the pattern). 
	           % hit at location nref corresponds to 0 delay of the pattern
                   % Likewise we reference the delay of the maximum
	 	   % statistic to thisnref. 


 		   iprod = match_pat(stat,pattern,gamma,...
        	             hits(usehits)-nref,mode);
                   if absiprod_on
	             iprod = abs(iprod);
	           end
			
		   [dmat(mind,1),mi] = max(iprod);
                   dmat(mind,2) = hits(usehits(mi))-thisnref;
		  end		
		 end

		elseif(0)
%		elseif(numtest == 3) 
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%peak tracking with norm peak hits
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		 for mind = 1:nummatch
 	          mscale = matchscales(mind);
		  usehits = find(nkmax-1 == mscale);
                  if ~isempty(usehits)
      		   eval(['pattern = pat',num2str(mscale),';']);

	           %note: thisnref is the peak location of the scaling
		   % the nref (peak location of the scaling function used to
                   % make the pattern). 
	           % hit at location nref corresponds to 0 delay of the pattern
                   % Likewise we reference the delay of the maximum
	 	   % statistic to thisnref. 


 		   iprod = match_pat(stat,pattern,gamma,...
        	             nhits(usehits)-nref,mode);
                   if absiprod_on
	             iprod = abs(iprod);
	           end
			
		   [dmat(mind,1),mi] = max(iprod);
                   dmat(mind,2) = nhits(usehits(mi))-thisnref;
		  end		
		 end



		elseif(numtest == 4)
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%peak tracking with hits, with match over scales
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                  for mind = 1:nummatch
 	          mscale = matchscales(mind);
      		    eval(['pattern = pat',num2str(mscale),';']);
 		    iprod = match_pat(stat,pattern,gamma,...
        	             hits - nref,mode);
                    if absiprod_on
	             iprod = abs(iprod);
	            end
		    [dmat(mind,1),mi] = max(iprod);
                    dmat(mind,2) = hits(mi)-thisnref;
		  end

		elseif(0)% skip this test for
		%elseif(numtest == 5)
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%peak tracking with norm hits, with match over scales
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                  for mind = 1:nummatch
 	          mscale = matchscales(mind);
      		    eval(['pattern = pat',num2str(mscale),';']);
 		    iprod = match_pat(stat,pattern,gamma,...
        	             nhits - nref,mode);
                    if absiprod_on
	             iprod = abs(iprod);
	            end
		    [dmat(mind,1),mi] = max(iprod);
                    dmat(mind,2) = nhits(mi)-thisnref;
		  end

		elseif(numtest == 6)
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		% use peak at ktrack scales,, match over scales
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		for mind = 1:nummatch
 	          mscale = matchscales(mind);
      		    eval(['pattern = pat',num2str(mscale),';']);
 		    iprod = match_pat(stat,pattern,gamma,...
        	             maxhits - nref,mode);
                    if absiprod_on
	             iprod = abs(iprod);
	            end
		    [dmat(mind,1),mi] = max(iprod);
                    dmat(mind,2) = maxhits(mi)-thisnref;
                end
        


		elseif(numtest == 7 ) %skip test 8
%		elseif(numtest == 7 | numtest == 8)
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%peak tracking, with match over delays
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		 for mind = 1:nummatch
 	          mscale = matchscales(mind);
		 if numtest == 7
		  usehits = find(kmax-1 == mscale);
		 else
		  usehits = find(nkmax-1 == mscale);
		 end
                  if ~isempty(usehits)
      		   eval(['pattern = pat',num2str(mscale),';']);
			
                   %make up a vector of  a range of
		   % delays about each hit location

		    len_hvec = ndelay*length(usehits);
		    hitvec = zeros(len_hvec,1);
		    hitvec2 = zeros(len_hvec,1);
	            if numtest == 7
 		     hitvec(1:ndelay:len_hvec) = hits(usehits);
	            else
 		     hitvec(1:ndelay:len_hvec) = nhits(usehits);
                    end
		    hitvec2(1:ndelay:len_hvec) = ones(length(usehits),1);
                    hitvec = filter(ones(ndelay,1),1,hitvec);
		    hitvec2 = filter(rdelay,1,hitvec2);
		    hitvec = hitvec + hitvec2;
			

 		   iprod = match_pat(stat,pattern,gamma,...
        	             hitvec - nref,mode);
                   if absiprod_on
	             iprod = abs(iprod);
	           end
		   [dmat(mind,1),mi] = max(iprod);
                   dmat(mind,2) = hitvec(mi)-thisnref;
		  end		
		 end

		elseif(numtest == 9 ) %skip test 10
%		elseif(numtest == 9 | numtest == 10)
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%peak tracking, with match over scales and delays
                %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 		 for mind = 1:nummatch
 	          mscale = matchscales(mind);
      		  eval(['pattern = pat',num2str(mscale),';']);

		    len_hvec = ndelay*length(hits);
		    hitvec = zeros(len_hvec,1);
		    hitvec2 = zeros(len_hvec,1);
	            if numtest == 9
		     hitvec(1:ndelay:len_hvec) = hits;
		    else
		     hitvec(1:ndelay:len_hvec) = nhits;
		    end
		    hitvec2(1:ndelay:len_hvec) = ones(length(hits),1);
                    hitvec = filter(ones(ndelay,1),1,hitvec);
		    hitvec2 = filter(rdelay,1,hitvec2);
		    hitvec = hitvec + hitvec2;

 		  iprod = match_pat(stat,pattern,gamma,...
        	             hitvec-nref,mode);
                   if absiprod_on
	             iprod = abs(iprod);
	           end

		  [dmat(mind,1),mi] = max(iprod);
                  dmat(mind,2) = hitvec(mi)-thisnref;
		 end


		end



		[m,mi] = max(dmat(:,1));
		tindex = 2*(numtest-1);
		eval(sprintf('det_stat%d(trial,tindex+toff) = m;',detwidth));
		eval(sprintf('est_delay%d(trial,tindex+toff) = dmat(mi,2);',detwidth));
		eval(sprintf('est_scale%d(trial,tindex+toff) = matchscales(mi);',detwidth));





           end


% Copyright (c) 1998 Thomas T. Liu

